#include <poll.h>
#include <errno.h>
#include <unistd.h>

#include "socket.hh"

void RedirectWithListen(int port)
{
    Socket gruu;
    gruu.BecomeListenerTCP(port);
    Socket gruu2;
    gruu2.AcceptTCP(gruu);
    dup2(gruu2.fd, 0);
    dup2(gruu2.fd, 1);
}

void RedirectWithConnect(int port, const char *ip = "127.0.0.1", int srcport)
{
    Socket gruu;
    gruu.BecomeConnecterTCP(port, ip, srcport);

    struct pollfd tmp = { gruu.fd, POLLIN | POLLOUT, 0 };
    while(poll(&tmp, 1, -1) < 0 && errno == EINTR);
    
    if(tmp.revents & POLLERR)
    {
        errno = gruu.CheckError();
        return;
    }
    
    dup2(gruu.fd, 0);
    dup2(gruu.fd, 1);
}
